
### 通义灵码-灵动指间，快码加编，你的智能编码助手
### TONGYI Lingma-Your AI Coding Assistant. Type less, Code more.

[通义灵码](https://tongyi.aliyun.com/lingma)，是一款基于通义大模型的智能编码辅助工具，提供行级/函数级实时续写、自然语言生成代码、单元测试生成、代码注释生成、代码解释、研发智能问答、异常报错排查等能力，并针对阿里云 SDK/API 的使用场景调优，为开发者带来高效、流畅的编码体验。
- 兼容 Visual Studio Code、JetBrains IDEs 等主流 IDE；  
- 支持 Java、Python、Go、C/C++/C#、JavaScript、TypeScript、PHP、Ruby、Rust、Scala 等主流编程语言。
       
[TONGYI Lingma](https://tongyi.aliyun.com/lingma) is an AI coding assistant, based on TONGYI large language model developed by Alibaba Cloud. TONGYI Lingma provides line or method level code generation, natural language to code, unit test generation, comment generation, code explanation, AI coding chat and document/code search etc., aiming to provide developers with efficient, flowing and graceful coding experience.
- TONGYI Lingma is available with Visual Studio Code, JetBrains IDEs.
- Supported language: Java, Python, Go, C/C++/C#, JavaScript, TypeScript, PHP, Ruby, Rust, Scala and other programming languages.

### 行级/函数级实时续写 Line or method level code generation   
根据语法和跨文件的上下文，实时生成建议代码。      
Generate suggested code in real-time based on programming language and cross file context.
![](https://img.alicdn.com/imgextra/i3/O1CN01NHx98i27CanHrcMND_!!6000000007761-0-tps-1440-525.jpg)


### 自然语言生成代码  Natural language to code
通过自然语言描述你想要的功能，可直接在编辑器区生成代码及相关注释，编码心流不间断。  
Typing what you want in natural language, Lingma will generate code and comments right in the editor, keeping your flow.
![](https://img.alicdn.com/imgextra/i2/O1CN01LKJ7NB1Dj0LESELvT_!!6000000000251-0-tps-1440-535.jpg)

### 单元测试生成  Generate unit test
支持 JUnit、Mockito、Spring Test、unit test、pytest 等框架生成单元测试。  
Generate unit tests using frameworks such as JUnit, Mockito, Spring Test, unit test and pytest, etc.
![](https://img.alicdn.com/imgextra/i2/O1CN01xtaD4j1MDhoe7tlX1_!!6000000001401-0-tps-1440-571.jpg)

### 代码注释生成  Generate comment
一键生成方法注释及行间注释，节省你写代码注释的时间，有效提升代码可读性。   
Just click and Lingma will generate method and inline comments, saving your time and improving the code more readable.
![](https://img.alicdn.com/imgextra/i4/O1CN01X5Hygp1cW3XOIZC1Z_!!6000000003607-0-tps-1440-553.jpg)

### 代码解释  Explain code
支持 30 多种语言的识别，选中代码后可自动识别编程语言并生成代码解释。跨越语言的边界，让你编码更自信。    
Supports over 30 programming languages, automatically recognizes programming languages and generates code explanations. Crossing the boundaries of programming languages and coding with more confidence.
![](https://img.alicdn.com/imgextra/i4/O1CN01peHkUp21gvKVOc0AA_!!6000000007015-0-tps-1440-444.jpg)

### 研发领域自由问答  AI Coding Chat
![](https://img.alicdn.com/imgextra/i1/O1CN01ydpABi1gZUyg6kDFG_!!6000000004156-0-tps-1440-616.jpg)

### 支持的 IDE 及操作系统  Supported IDEs and systems
- Windows 7 or later/ macOS/ Linux
- JetBrains IDEs (IntelliJ IDEA / PyCharm / GoLand / WebStorm etc.) 2020.3 or later
- Visual Studio Code 1.68.0 or later

### 帮助文档 Docs
[通义灵码帮助文档](https://help.aliyun.com/document_detail/2590613.html)   
[TONGYI Lingma Docs](https://help.aliyun.com/document_detail/2590613.html)
    

### 隐私政策  Privacy Policy
[通义灵码隐私政策](https://help.aliyun.com/document_detail/2590617.html)   
[TONGYI Lingma Privacy Policy](https://help.aliyun.com/document_detail/2590617.html)


### 提交反馈  Share feedback
通义灵码是你的智能编码助手，期待着和你一起开启舒适、流畅的编码旅途。如果你在使用通义灵码的过程中遇到任何问题，请[提交反馈](https://developer.aliyun.com/ask/new?spm=a2c6h.13066369.question.23.38d01bdfIPOy5Z&excode=devops&exdcode=tongyilingma)给我们。     
With TONGYI Lingma as your copilot, we hope you will have a cosy coding journey. If you have any problems or suggestions about TONGYI Lingma, please share your [Feedback](https://developer.aliyun.com/ask/new?spm=a2c6h.13066369.question.23.38d01bdfIPOy5Z&excode=devops&exdcode=tongyilingma) with us.
